#ifndef __SMSSETTINGS_H__
#define __SMSSETTINGS_H__

struct smsui
{
	uint8 mode, mute;
};

struct smskeys
{
	uint8 kup, kdown, kleft, kright, kbutton1, kbutton2, kstart;
};

struct smsjoystick
{
	//uint8 stick_index;
	uint8 jbutton1, jbutton2, jstart, swapy;
};

struct smssettings
{
	smsui uisettings;
	smskeys keypad0;
	smskeys keypad1;
	smsjoystick joypad0;
	smsjoystick joypad1;
};

void GetSettings(smssettings &settings);
void SetSettings(const smssettings &settings);

#endif
