// Copyright Caz (2002)
// 1x dirtyathlon ASM CORE for Athlon Xp, draw using 4 16 bit dirty pixels, using pcmpeqw to only draw if the pixels have changed
// With this dirty pixel drawing the average usecs is 221, depending on the amount of pixels changing on screen,
// it is however always faster than basic full draw, 2xsai uses dirty pixels also, and we all like 2xsai don't we, mmm(yes!!)
{
	static uint32 i = 0;
	static clipping_rect *clip;
	static int32 y = 0, x = 0;
	
	m_locker->Lock();
	if(m_connected) {
		clip = m_cliplist;
	for(i = 0; i < m_numcliprects; i++, clip++)
		for(y = 0; y < m_bounds.bottom - m_bounds.top + 1; y++)
		 if (clip->top - m_bounds.top <= y && clip->bottom - m_bounds.top >= y) {
		 	uint8 *dst = (uint8 *)(m_bits + ((y) * (m_rowbytes)) +((clip->left) * m_bitsperpixel));
			uint8 *src = (uint8 *)sms_bmp->Bits() + ((y) * sms_bmp->BytesPerRow()) + ((clip->left - m_bounds.left) * m_bitsperpixel);
			uint8 *src2 = (uint8 *)sms_back_bmp->Bits() + ((y) * sms_back_bmp->BytesPerRow()) + ((clip->left - m_bounds.left) * m_bitsperpixel);

#ifndef __ASM_CORE__
		__asm__ __volatile("pushl %%ebx
							xorl %3, %3
							cmpl $8, %2
							jna finishdirty1x
							.align 16
							loop1xdirty:
							movq (%0), %%mm0
							movq (%4), %%mm1
								
							pcmpeqw %%mm0, %%mm1
							packsswb %%mm1, %%mm1
							movd %%mm1, %%ebx
							cmpl $0xffffffff, %%ebx
							jz end1xdirty
							movq %%mm0, (%1)
							movq %%mm0, (%4)
								
							end1xdirty:
							addl $8, %0
							addl $8, %1
							addl $8, %4
							incl %3
							cmpl %3, %2
							ja loop1xdirty
								
							finishdirty1x:
							popl %%ebx"
						
			:
			: "S"(src), "D"(dst), "c"((clip->right - clip->left + 1) >> 2), "a"(x), "d"(src2));
#else		
			x = 0;
			uint16 *t = (uint16 *)dst;
			uint16 *r = (uint16 *)src;
			while(x < (clip->right - clip->left + 1)) {
				t[x] = r[x++];
			}
#endif
		}
#ifndef __ASM_CORE__
	asm("
		 emms");
#endif
	}
	m_locker->Unlock();
}
