// Copyright Caz (2002)
// 1x normal
{
	static uint32 i = 0;
	static clipping_rect *clip;
	static int32 y = 0, x = 0;
	
	m_locker->Lock();
	if(m_connected) {
		clip = m_cliplist;
	for(i = 0; i < m_numcliprects; i++, clip++)
		 for(y = 0; y < (clip->bottom - clip->top)+1; y++) {
		 	uint8 *dst = (uint8 *)(m_bits + ((y + clip->top) * (m_rowbytes)) +((clip->left) * m_bitsperpixel));
			uint8 *src = (uint8 *)sms_bmp->Bits() + ((y) * sms_bmp->BytesPerRow());// + ((clip->left - m_bounds.left) * m_bitsperpixel);
#ifndef __ASM_CORE__
		__asm__ __volatile("xorl %3, %3
								.align 16
								loop1xfull:
								movq (%0), %%mm0
								movq %%mm0, (%1)
								addl $8, %0
								addl $8, %1
								incl %3
								cmpl %3, %2
								ja loop1xfull
								end1xfull:"
						
			:
			: "S"(src), "D"(dst), "c"((clip->right - clip->left + 1) >> 2), "a"(x));
#else		
			x = 0;
			uint16 *t = (uint16 *)dst;
			uint16 *r = (uint16 *)src;
			while(x < (clip->right - clip->left + 1)) {
				t[x] = r[x++];
			}
#endif
		}
#ifndef __ASM_CORE__
	asm("
		 emms");
#endif
	}
	m_locker->Unlock();
}
