// Copyright Caz (2002)
// 2x double mode
{
	static uint32 i = 0;
	static clipping_rect *clip;
	static int32 y = 0, x = 0;
	
	m_locker->Lock();
	if(m_connected) {
		clip = m_cliplist;
	for(i = 0; i < m_numcliprects; i++, clip++)
		for(y = 0; y < m_bounds.bottom - m_bounds.top + 1; y++)
		 if (clip->top - m_bounds.top <= y && clip->bottom - m_bounds.top >= y) {
		 	uint8 *dst = (uint8 *)(m_bits + ((y) * (m_rowbytes)) +((clip->left) * m_bitsperpixel));
			uint8 *src = (uint8 *)sms_bmp->Bits() + ((y >> 1) * sms_bmp->BytesPerRow()) + (((clip->left - m_bounds.left) >> 1) * m_bitsperpixel);
			//uint8 *src2 = (uint8 *)sms_back_bmp->Bits() + ((y) * sms_back_bmp->BytesPerRow()) + (((clip->left - m_bounds.left) >> 1) * m_bitsperpixel);

#ifndef __ASM_CORE__
			__asm__ __volatile("xorl %3, %3
								cmpl $8, %2
								jna end2x
								.align 16
								loop2x:
								movd (%0), %%mm0
								punpcklwd %%mm0, %%mm0
								movq %%mm0, (%1)
								addl $4, %0
								addl $8, %1
								incl %3
								cmpl %3, %2
								ja loop2x
								end2x:"
						
			:
			: "S"(src), "D"(dst), "c"((clip->right - clip->left + 1) >> 2), "a"(x));
#else
	//do_line_dirty(src, src2, dst, (clip->right - clip->left + 1));
			x = 0;
			uint16 *t = (uint16 *)dst;
			uint16 *r = (uint16 *)src;
			uint16 reg16;
			while(x < (clip->right - clip->left + 1) >> 1) {
				reg16 = r[x++];
				*t++ = reg16;
				*t++ = reg16;
			}
#endif
		}
#ifndef __ASM_CORE__
	asm("
		 emms");
#endif
	}
	m_locker->Unlock();
}