#ifndef __JOYINPUTVIEW_H__
#define __JOYINPUTVIEW_H__

class JoyInputView : public BView
{
public:
	JoyInputView(BRect rect, BWindow *front, Joystick *joystick);
	virtual ~JoyInputView();
	enum {
		BUTTON1, BUTTON2, START, MAX
	};
	virtual void Pulse();
	virtual void Draw(BRect updateRect);
	virtual void AttachedToWindow();
	virtual void MessageReceived(BMessage *m);
	virtual void SetInput(bool doinput) { input = doinput; }
	virtual bool IsInput() const { return input; }
	virtual void ChangeLabel(int index, int key);
	virtual void SetData(uint8 *which, bool *p);
private:
	BWindow *front;
	BStringView *sview;
	BCheckBox *swapy;
	int key;
	int input_num;
	bool input;
	BBitmap *tile_bitmap;
	BStringView *input_sviews[MAX];
	BBox *box;
	uint8 *which;
	bool *p;
	Joystick *joystick;
	int k;
};

#endif